// Hyperlink.cpp : implementation file
//

#include "stdafx.h"
#include "HyperlinkSample.h"
#include "Hyperlink.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CHyperlink


/***********************************************************************/
/// <b>Function: CHyperlink</b>
///
///	\param	NONE
///
/// \remarks	Constructor
///
/***********************************************************************/
CHyperlink::CHyperlink()
{
	m_HypFont.CreateFont(15,0,0,0,FW_THIN,0,1,0,0,0,0,0,0,"Tahoma");
	m_URL = _T("http://www.go4expert.com/");
	m_HypCursor = NULL;
}


/***********************************************************************/
/// <b>Function: ~CHyperlink</b>
///
///	\param	NONE
///
/// \remarks	Destructor
///
/***********************************************************************/
CHyperlink::~CHyperlink()
{
	::DeleteObject(m_HypCursor);
	::DeleteObject(m_HypFont);

}


BEGIN_MESSAGE_MAP(CHyperlink, CStatic)
	//{{AFX_MSG_MAP(CHyperlink)
	ON_WM_PAINT()
	ON_WM_NCHITTEST()
	ON_WM_LBUTTONUP()
	ON_WM_SETCURSOR()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CHyperlink message handlers


/***********************************************************************/
/// <b>Function: OnPaint</b>
///
///	\param	NONE
///
/// \return	void 
///
/// \remarks	WM_PAINT HANDLER
///
/***********************************************************************/
void CHyperlink::OnPaint() 
{
	// TODO: Add your message handler code here
	
	CPaintDC		dc (this);		// device context for painting
	RECT			rectWnd;		// window rectangle
	CString			strText;		// window text
	
	dc.SelectObject(&m_HypFont);
	dc.SetBkMode(TRANSPARENT);

	GetWindowText(strText);
	GetClientRect(&rectWnd);
	
	dc.SetTextColor( RGB(0, 0, 255) );

	/// Draw text
	::DrawTextEx(dc.m_hDC, strText.GetBuffer(0), strText.GetLength(), &rectWnd, DT_LEFT, NULL);
	strText.ReleaseBuffer();

	// Do not call CStatic::OnPaint() for painting messages
}


/***********************************************************************/
/// <b>Function: PreSubclassWindow</b>
///
///	\param	NONE
///
/// \return	void 
///
/// \remarks	Initialize variables specially the hand 
///				cursor before the window is created.
///				"Default hand cursor" from Paul DiLascia's Jan 1998 
///				MSJ article.
///
/***********************************************************************/
void CHyperlink::PreSubclassWindow() 
{
	// TODO: Add your specialized code here and/or call the base class
	
    if (m_HypCursor == NULL)                // No cursor handle - load our own
    {
        // Get the windows directory
        CString strWndDir;
        GetWindowsDirectory(strWndDir.GetBuffer(MAX_PATH), MAX_PATH);
        strWndDir.ReleaseBuffer();

        strWndDir += _T("\\winhlp32.exe");
        // This retrieves cursor #106 from winhlp32.exe, which is a hand pointer
        HMODULE hModule = LoadLibrary(strWndDir);
        if (hModule) {
            HCURSOR hHandCursor = ::LoadCursor(hModule, MAKEINTRESOURCE(106));
            if (hHandCursor)
                m_HypCursor = CopyCursor(hHandCursor);
        }
        FreeLibrary(hModule);
    }

	CStatic::PreSubclassWindow();
}


/***********************************************************************/
/// <b>Function: OnNcHitTest</b>
///
/// \param	point	(in\out)
///
/// \return	UINT 
///
/// \remarks	Override WM_NCHITTEST message handler to handle 
///				the Mouse events to be handled by the Client and not 
///				the parent window.
///
/***********************************************************************/
UINT CHyperlink::OnNcHitTest(CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	return HTCLIENT  ;
	//return CStatic::OnNcHitTest(point);
}


/***********************************************************************/
/// <b>Function: OnLButtonUp</b>
///
/// \param	nFlags	(in\out)
///
/// \param	point	(in\out)
///
/// \return	void 
///
/// \remarks	Launch the web browser to display the URL.
///
/***********************************************************************/
void CHyperlink::OnLButtonUp(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	HINSTANCE result = ShellExecute(NULL, _T("open"), m_URL, NULL,NULL, SW_SHOW);

	CStatic::OnLButtonUp(nFlags, point);
}


/***********************************************************************/
/// <b>Function: OnSetCursor</b>
///
/// \param	pWnd	(in\out)
///
/// \param	nHitTest	(in\out)
///
/// \param	message	(in\out)
///
/// \return	BOOL 
///
/// \remarks	Change the cursor so that the cursor is always hand cursor
///
/***********************************************************************/
BOOL CHyperlink::OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message) 
{
	// TODO: Add your message handler code here and/or call default
	if (m_HypCursor)
    {
        ::SetCursor(m_HypCursor);
        return TRUE;
    }
    return FALSE;
	//return CStatic::OnSetCursor(pWnd, nHitTest, message);
}
